com.amazonaws.services.machinelearning

## Class AmazonMachineLearningClient

- java.lang.Object
- - com.amazonaws.AmazonWebServiceClient
  - - com.amazonaws.services.machinelearning.AmazonMachineLearningClient

All Implemented Interfaces:
  AmazonMachineLearning

Direct Known Subclasses:
  AmazonMachineLearningAsyncClient

    @ThreadSafe
    public class AmazonMachineLearningClient
    extends AmazonWebServiceClient
    implements AmazonMachineLearning

Client for accessing Amazon Machine Learning. All service calls made using this client are blocking, and will not return until the service call completes.

Definition of the public APIs exposed by Amazon Machine Learning

### Field Summary

Fields
`protected static ClientConfigurationFactory` `configFactory` Client configuration factory providing ClientConfigurations tailored to this client

### Fields inherited from class com.amazonaws.AmazonWebServiceClient

`client, clientConfiguration, endpoint, LOGGING_AWS_REQUEST_METRIC, requestHandler2s, timeOffset`

### Fields inherited from interface com.amazonaws.services.machinelearning.AmazonMachineLearning

`ENDPOINT_PREFIX`

### Constructor Summary

Constructors
Constructor and Description
`AmazonMachineLearningClient()` Constructs a new client to invoke service methods on Amazon Machine Learning.
`AmazonMachineLearningClient(AWSCredentials awsCredentials)` Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials.
`AmazonMachineLearningClient(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials and client configuration options.
`AmazonMachineLearningClient(AWSCredentialsProvider awsCredentialsProvider)` Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials provider.
`AmazonMachineLearningClient(AWSCredentialsProvider awsCredentialsProvider, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials provider and client configuration options.
`AmazonMachineLearningClient(AWSCredentialsProvider awsCredentialsProvider, ClientConfiguration clientConfiguration, RequestMetricCollector requestMetricCollector)` Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials provider, client configuration options, and request metric collector.
`AmazonMachineLearningClient(ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on Amazon Machine Learning.

### Method Summary

All Methods Instance Methods Concrete Methods
`AddTagsResult` `addTags(AddTagsRequest addTagsRequest)` Adds one or more tags to an object, up to a limit of 10.
`CreateBatchPredictionResult` `createBatchPrediction(CreateBatchPredictionRequest createBatchPredictionRequest)` Generates predictions for a group of observations.
`CreateDataSourceFromRDSResult` `createDataSourceFromRDS(CreateDataSourceFromRDSRequest createDataSourceFromRDSRequest)` Creates a `DataSource` object from an Amazon Relational Database Service (Amazon RDS).
`CreateDataSourceFromRedshiftResult` `createDataSourceFromRedshift(CreateDataSourceFromRedshiftRequest createDataSourceFromRedshiftRequest)` Creates a `DataSource` from a database hosted on an Amazon Redshift cluster.
`CreateDataSourceFromS3Result` `createDataSourceFromS3(CreateDataSourceFromS3Request createDataSourceFromS3Request)` Creates a `DataSource` object.
`CreateEvaluationResult` `createEvaluation(CreateEvaluationRequest createEvaluationRequest)` Creates a new `Evaluation` of an `MLModel`.
`CreateMLModelResult` `createMLModel(CreateMLModelRequest createMLModelRequest)` Creates a new `MLModel` using the `DataSource` and the recipe as information sources.
`CreateRealtimeEndpointResult` `createRealtimeEndpoint(CreateRealtimeEndpointRequest createRealtimeEndpointRequest)` Creates a real-time endpoint for the `MLModel`.
`DeleteBatchPredictionResult` `deleteBatchPrediction(DeleteBatchPredictionRequest deleteBatchPredictionRequest)` Assigns the DELETED status to a `BatchPrediction`, rendering it unusable.
`DeleteDataSourceResult` `deleteDataSource(DeleteDataSourceRequest deleteDataSourceRequest)` Assigns the DELETED status to a `DataSource`, rendering it unusable.
`DeleteEvaluationResult` `deleteEvaluation(DeleteEvaluationRequest deleteEvaluationRequest)` Assigns the `DELETED` status to an `Evaluation`, rendering it unusable.
`DeleteMLModelResult` `deleteMLModel(DeleteMLModelRequest deleteMLModelRequest)` Assigns the `DELETED` status to an `MLModel`, rendering it unusable.
`DeleteRealtimeEndpointResult` `deleteRealtimeEndpoint(DeleteRealtimeEndpointRequest deleteRealtimeEndpointRequest)` Deletes a real time endpoint of an `MLModel`.
`DeleteTagsResult` `deleteTags(DeleteTagsRequest deleteTagsRequest)` Deletes the specified tags associated with an ML object.
`DescribeBatchPredictionsResult` `describeBatchPredictions()` Simplified method form for invoking the DescribeBatchPredictions operation.
`DescribeBatchPredictionsResult` `describeBatchPredictions(DescribeBatchPredictionsRequest describeBatchPredictionsRequest)` Returns a list of `BatchPrediction` operations that match the search criteria in the request.
`DescribeDataSourcesResult` `describeDataSources()` Simplified method form for invoking the DescribeDataSources operation.
`DescribeDataSourcesResult` `describeDataSources(DescribeDataSourcesRequest describeDataSourcesRequest)` Returns a list of `DataSource` that match the search criteria in the request.
`DescribeEvaluationsResult` `describeEvaluations()` Simplified method form for invoking the DescribeEvaluations operation.
`DescribeEvaluationsResult` `describeEvaluations(DescribeEvaluationsRequest describeEvaluationsRequest)` Returns a list of `DescribeEvaluations` that match the search criteria in the request.
`DescribeMLModelsResult` `describeMLModels()` Simplified method form for invoking the DescribeMLModels operation.
`DescribeMLModelsResult` `describeMLModels(DescribeMLModelsRequest describeMLModelsRequest)` Returns a list of `MLModel` that match the search criteria in the request.
`DescribeTagsResult` `describeTags(DescribeTagsRequest describeTagsRequest)` Describes one or more of the tags for your Amazon ML object.
`GetBatchPredictionResult` `getBatchPrediction(GetBatchPredictionRequest getBatchPredictionRequest)` Returns a `BatchPrediction` that includes detailed metadata, status, and data file information for a `Batch Prediction` request.
`ResponseMetadata` `getCachedResponseMetadata(AmazonWebServiceRequest request)` Returns additional metadata for a previously executed successful, request, typically used for debugging issues where a service isn't acting as expected.
`GetDataSourceResult` `getDataSource(GetDataSourceRequest getDataSourceRequest)` Returns a `DataSource` that includes metadata and data file information, as well as the current status of the `DataSource`.
`GetEvaluationResult` `getEvaluation(GetEvaluationRequest getEvaluationRequest)` Returns an `Evaluation` that includes metadata as well as the current status of the `Evaluation`.
`GetMLModelResult` `getMLModel(GetMLModelRequest getMLModelRequest)` Returns an `MLModel` that includes detailed metadata, data source information, and the current status of the `MLModel`.
`PredictResult` `predict(PredictRequest predictRequest)` Generates a prediction for the observation using the specified `ML Model`.
`UpdateBatchPredictionResult` `updateBatchPrediction(UpdateBatchPredictionRequest updateBatchPredictionRequest)` Updates the `BatchPredictionName` of a `BatchPrediction`.
`UpdateDataSourceResult` `updateDataSource(UpdateDataSourceRequest updateDataSourceRequest)` Updates the `DataSourceName` of a `DataSource`.
`UpdateEvaluationResult` `updateEvaluation(UpdateEvaluationRequest updateEvaluationRequest)` Updates the `EvaluationName` of an `Evaluation`.
`UpdateMLModelResult` `updateMLModel(UpdateMLModelRequest updateMLModelRequest)` Updates the `MLModelName` and the `ScoreThreshold` of an `MLModel`.
`AmazonMachineLearningWaiters` `waiters()`

### Methods inherited from class com.amazonaws.AmazonWebServiceClient

`addRequestHandler, addRequestHandler, beforeMarshalling, calculateCRC32FromCompressedData, checkMutability, configureRegion, createExecutionContext, createExecutionContext, createExecutionContext, createSignerProvider, endClientExecution, endClientExecution, getEndpointPrefix, getRequestMetricsCollector, getServiceAbbreviation, getServiceName, getServiceNameIntern, getSigner, getSignerByURI, getSignerProvider, getSignerRegionOverride, getTimeOffset, isProfilingEnabled, isRequestMetricsEnabled, makeImmutable, removeRequestHandler, removeRequestHandler, requestMetricCollector, setEndpoint, setEndpointPrefix, setRegion, setServiceNameIntern, setSignerRegionOverride, setTimeOffset, shutdown, useStrictHostNameVerification, withEndpoint, withRegion, withRegion, withTimeOffset`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.amazonaws.services.machinelearning.AmazonMachineLearning

`setEndpoint, setRegion, shutdown`

### Field Detail

#### configFactory

    protected static final ClientConfigurationFactory configFactory

Client configuration factory providing ClientConfigurations tailored to this client

### Constructor Detail

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient()

Constructs a new client to invoke service methods on Amazon Machine Learning. A credentials provider chain will be used that searches for credentials in this order:

- Environment Variables - AWS_ACCESS_KEY_ID and AWS_SECRET_KEY
- Java System Properties - aws.accessKeyId and aws.secretKey
- Instance profile credentials delivered through the Amazon EC2 metadata service

All service calls made using this new client object are blocking, and will not return until the service call completes.

See Also:
  `DefaultAWSCredentialsProviderChain`

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient(ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on Amazon Machine Learning. A credentials provider chain will be used that searches for credentials in this order:

- Environment Variables - AWS_ACCESS_KEY_ID and AWS_SECRET_KEY
- Java System Properties - aws.accessKeyId and aws.secretKey
- Instance profile credentials delivered through the Amazon EC2 metadata service

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Machine Learning (ex: proxy settings, retry counts, etc.).
See Also:
  `DefaultAWSCredentialsProviderChain`

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient(AWSCredentials awsCredentials)

Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient(AWSCredentials awsCredentials,
                                       ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials and client configuration options.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Machine Learning (ex: proxy settings, retry counts, etc.).

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient(AWSCredentialsProvider awsCredentialsProvider)

Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials provider.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient(AWSCredentialsProvider awsCredentialsProvider,
                                       ClientConfiguration clientConfiguration)

Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials provider and client configuration options.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Machine Learning (ex: proxy settings, retry counts, etc.).

#### AmazonMachineLearningClient

    public AmazonMachineLearningClient(AWSCredentialsProvider awsCredentialsProvider,
                                       ClientConfiguration clientConfiguration,
                                       RequestMetricCollector requestMetricCollector)

Constructs a new client to invoke service methods on Amazon Machine Learning using the specified AWS account credentials provider, client configuration options, and request metric collector.

All service calls made using this new client object are blocking, and will not return until the service call completes.

Parameters:
  `awsCredentialsProvider` - The AWS credentials provider which will provide credentials to authenticate requests with AWS services.
  `clientConfiguration` - The client configuration options controlling how this client connects to Amazon Machine Learning (ex: proxy settings, retry counts, etc.).
  `requestMetricCollector` - optional request metric collector

### Method Detail

#### addTags

    public AddTagsResult addTags(AddTagsRequest addTagsRequest)

Adds one or more tags to an object, up to a limit of 10. Each tag consists of a key and an optional value. If you add a tag using a key that is already associated with the ML object, `AddTags` updates the tag's value.

Specified by:
  `addTags` in interface `AmazonMachineLearning`
Parameters:
  `addTagsRequest` -
Returns:
  Result of the AddTags operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InvalidTagException`
  `TagLimitExceededException`
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### createBatchPrediction

    public CreateBatchPredictionResult createBatchPrediction(CreateBatchPredictionRequest createBatchPredictionRequest)

Generates predictions for a group of observations. The observations to process exist in one or more data files referenced by a `DataSource`. This operation creates a new `BatchPrediction`, and uses an `MLModel` and the data files referenced by the `DataSource` as information sources.

`CreateBatchPrediction` is an asynchronous operation. In response to `CreateBatchPrediction`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `BatchPrediction` status to `PENDING`. After the `BatchPrediction` completes, Amazon ML sets the status to `COMPLETED`.

You can poll for status updates by using the GetBatchPrediction operation and checking the `Status` parameter of the result. After the `COMPLETED` status appears, the results are available in the location specified by the `OutputUri` parameter.

Specified by:
  `createBatchPrediction` in interface `AmazonMachineLearning`
Parameters:
  `createBatchPredictionRequest` -
Returns:
  Result of the CreateBatchPrediction operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `IdempotentParameterMismatchException` - A second request to use or change an object was not allowed. This can result from retrying a request using a parameter that was not present in the original request.

#### createDataSourceFromRDS

    public CreateDataSourceFromRDSResult createDataSourceFromRDS(CreateDataSourceFromRDSRequest createDataSourceFromRDSRequest)

Creates a `DataSource` object from an Amazon Relational Database Service (Amazon RDS). A `DataSource` references data that can be used to perform `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromRDS` is an asynchronous operation. In response to `CreateDataSourceFromRDS`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` is created and ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in the `COMPLETED` or `PENDING` state can be used only to perform `>CreateMLModel`>, `CreateEvaluation`, or `CreateBatchPrediction` operations.

If Amazon ML cannot accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

Specified by:
  `createDataSourceFromRDS` in interface `AmazonMachineLearning`
Parameters:
  `createDataSourceFromRDSRequest` -
Returns:
  Result of the CreateDataSourceFromRDS operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `IdempotentParameterMismatchException` - A second request to use or change an object was not allowed. This can result from retrying a request using a parameter that was not present in the original request.

#### createDataSourceFromRedshift

    public CreateDataSourceFromRedshiftResult createDataSourceFromRedshift(CreateDataSourceFromRedshiftRequest createDataSourceFromRedshiftRequest)

Creates a `DataSource` from a database hosted on an Amazon Redshift cluster. A `DataSource` references data that can be used to perform either `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromRedshift` is an asynchronous operation. In response to `CreateDataSourceFromRedshift`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` is created and ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in `COMPLETED` or `PENDING` states can be used to perform only `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

If Amazon ML can't accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

The observations should be contained in the database hosted on an Amazon Redshift cluster and should be specified by a `SelectSqlQuery` query. Amazon ML executes an `Unload` command in Amazon Redshift to transfer the result set of the `SelectSqlQuery` query to `S3StagingLocation`.

After the `DataSource` has been created, it's ready for use in evaluations and batch predictions. If you plan to use the `DataSource` to train an `MLModel`, the `DataSource` also requires a recipe. A recipe describes how each input variable will be used in training an `MLModel`. Will the variable be included or excluded from training? Will the variable be manipulated; for example, will it be combined with another variable or will it be split apart into word combinations? The recipe provides answers to these questions.

You can't change an existing datasource, but you can copy and modify the settings from an existing Amazon Redshift datasource to create a new datasource. To do so, call `GetDataSource` for an existing datasource and copy the values to a `CreateDataSource` call. Change the settings that you want to change and make sure that all required fields have the appropriate values.

Specified by:
  `createDataSourceFromRedshift` in interface `AmazonMachineLearning`
Parameters:
  `createDataSourceFromRedshiftRequest` -
Returns:
  Result of the CreateDataSourceFromRedshift operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `IdempotentParameterMismatchException` - A second request to use or change an object was not allowed. This can result from retrying a request using a parameter that was not present in the original request.

#### createDataSourceFromS3

    public CreateDataSourceFromS3Result createDataSourceFromS3(CreateDataSourceFromS3Request createDataSourceFromS3Request)

Creates a `DataSource` object. A `DataSource` references data that can be used to perform `CreateMLModel`, `CreateEvaluation`, or `CreateBatchPrediction` operations.

`CreateDataSourceFromS3` is an asynchronous operation. In response to `CreateDataSourceFromS3`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `DataSource` status to `PENDING`. After the `DataSource` has been created and is ready for use, Amazon ML sets the `Status` parameter to `COMPLETED`. `DataSource` in the `COMPLETED` or `PENDING` state can be used to perform only `CreateMLModel`, `CreateEvaluation` or `CreateBatchPrediction` operations.

If Amazon ML can't accept the input source, it sets the `Status` parameter to `FAILED` and includes an error message in the `Message` attribute of the `GetDataSource` operation response.

The observation data used in a `DataSource` should be ready to use; that is, it should have a consistent structure, and missing data values should be kept to a minimum. The observation data must reside in one or more .csv files in an Amazon Simple Storage Service (Amazon S3) location, along with a schema that describes the data items by name and type. The same schema must be used for all of the data files referenced by the `DataSource`.

After the `DataSource` has been created, it's ready to use in evaluations and batch predictions. If you plan to use the `DataSource` to train an `MLModel`, the `DataSource` also needs a recipe. A recipe describes how each input variable will be used in training an `MLModel`. Will the variable be included or excluded from training? Will the variable be manipulated; for example, will it be combined with another variable or will it be split apart into word combinations? The recipe provides answers to these questions.

Specified by:
  `createDataSourceFromS3` in interface `AmazonMachineLearning`
Parameters:
  `createDataSourceFromS3Request` -
Returns:
  Result of the CreateDataSourceFromS3 operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `IdempotentParameterMismatchException` - A second request to use or change an object was not allowed. This can result from retrying a request using a parameter that was not present in the original request.

#### createEvaluation

    public CreateEvaluationResult createEvaluation(CreateEvaluationRequest createEvaluationRequest)

Creates a new `Evaluation` of an `MLModel`. An `MLModel` is evaluated on a set of observations associated to a `DataSource`. Like a `DataSource` for an `MLModel`, the `DataSource` for an `Evaluation` contains values for the `Target Variable`. The `Evaluation` compares the predicted result for each observation to the actual outcome and provides a summary so that you know how effective the `MLModel` functions on the test data. Evaluation generates a relevant performance metric, such as BinaryAUC, RegressionRMSE or MulticlassAvgFScore based on the corresponding `MLModelType`: `BINARY`, `REGRESSION` or `MULTICLASS`.

`CreateEvaluation` is an asynchronous operation. In response to `CreateEvaluation`, Amazon Machine Learning (Amazon ML) immediately returns and sets the evaluation status to `PENDING`. After the `Evaluation` is created and ready for use, Amazon ML sets the status to `COMPLETED`.

You can use the `GetEvaluation` operation to check progress of the evaluation during the creation operation.

Specified by:
  `createEvaluation` in interface `AmazonMachineLearning`
Parameters:
  `createEvaluationRequest` -
Returns:
  Result of the CreateEvaluation operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `IdempotentParameterMismatchException` - A second request to use or change an object was not allowed. This can result from retrying a request using a parameter that was not present in the original request.

#### createMLModel

    public CreateMLModelResult createMLModel(CreateMLModelRequest createMLModelRequest)

Creates a new `MLModel` using the `DataSource` and the recipe as information sources.

An `MLModel` is nearly immutable. Users can update only the `MLModelName` and the `ScoreThreshold` in an `MLModel` without creating a new `MLModel`.

`CreateMLModel` is an asynchronous operation. In response to `CreateMLModel`, Amazon Machine Learning (Amazon ML) immediately returns and sets the `MLModel` status to `PENDING` . After the `MLModel` has been created and ready is for use, Amazon ML sets the status to `COMPLETED`.

You can use the `GetMLModel` operation to check the progress of the `MLModel` during the creation operation.

`CreateMLModel` requires a `DataSource` with computed statistics, which can be created by setting `ComputeStatistics` to `true` in `CreateDataSourceFromRDS`, `CreateDataSourceFromS3`, or `CreateDataSourceFromRedshift` operations.

Specified by:
  `createMLModel` in interface `AmazonMachineLearning`
Parameters:
  `createMLModelRequest` -
Returns:
  Result of the CreateMLModel operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `IdempotentParameterMismatchException` - A second request to use or change an object was not allowed. This can result from retrying a request using a parameter that was not present in the original request.

#### createRealtimeEndpoint

    public CreateRealtimeEndpointResult createRealtimeEndpoint(CreateRealtimeEndpointRequest createRealtimeEndpointRequest)

Creates a real-time endpoint for the `MLModel`. The endpoint contains the URI of the `MLModel`; that is, the location to send real-time prediction requests for the specified `MLModel`.

Specified by:
  `createRealtimeEndpoint` in interface `AmazonMachineLearning`
Parameters:
  `createRealtimeEndpointRequest` -
Returns:
  Result of the CreateRealtimeEndpoint operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### deleteBatchPrediction

    public DeleteBatchPredictionResult deleteBatchPrediction(DeleteBatchPredictionRequest deleteBatchPredictionRequest)

Assigns the DELETED status to a `BatchPrediction`, rendering it unusable.

After using the `DeleteBatchPrediction` operation, you can use the GetBatchPrediction operation to verify that the status of the `BatchPrediction` changed to DELETED.

Caution: The result of the `DeleteBatchPrediction` operation is irreversible.

Specified by:
  `deleteBatchPrediction` in interface `AmazonMachineLearning`
Parameters:
  `deleteBatchPredictionRequest` -
Returns:
  Result of the DeleteBatchPrediction operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### deleteDataSource

    public DeleteDataSourceResult deleteDataSource(DeleteDataSourceRequest deleteDataSourceRequest)

Assigns the DELETED status to a `DataSource`, rendering it unusable.

After using the `DeleteDataSource` operation, you can use the GetDataSource operation to verify that the status of the `DataSource` changed to DELETED.

Caution: The results of the `DeleteDataSource` operation are irreversible.

Specified by:
  `deleteDataSource` in interface `AmazonMachineLearning`
Parameters:
  `deleteDataSourceRequest` -
Returns:
  Result of the DeleteDataSource operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### deleteEvaluation

    public DeleteEvaluationResult deleteEvaluation(DeleteEvaluationRequest deleteEvaluationRequest)

Assigns the `DELETED` status to an `Evaluation`, rendering it unusable.

After invoking the `DeleteEvaluation` operation, you can use the `GetEvaluation` operation to verify that the status of the `Evaluation` changed to `DELETED`.

<caution>Caution

The results of the `DeleteEvaluation` operation are irreversible.

</caution>

Specified by:
  `deleteEvaluation` in interface `AmazonMachineLearning`
Parameters:
  `deleteEvaluationRequest` -
Returns:
  Result of the DeleteEvaluation operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### deleteMLModel

    public DeleteMLModelResult deleteMLModel(DeleteMLModelRequest deleteMLModelRequest)

Assigns the `DELETED` status to an `MLModel`, rendering it unusable.

After using the `DeleteMLModel` operation, you can use the `GetMLModel` operation to verify that the status of the `MLModel` changed to DELETED.

Caution: The result of the `DeleteMLModel` operation is irreversible.

Specified by:
  `deleteMLModel` in interface `AmazonMachineLearning`
Parameters:
  `deleteMLModelRequest` -
Returns:
  Result of the DeleteMLModel operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### deleteRealtimeEndpoint

    public DeleteRealtimeEndpointResult deleteRealtimeEndpoint(DeleteRealtimeEndpointRequest deleteRealtimeEndpointRequest)

Deletes a real time endpoint of an `MLModel`.

Specified by:
  `deleteRealtimeEndpoint` in interface `AmazonMachineLearning`
Parameters:
  `deleteRealtimeEndpointRequest` -
Returns:
  Result of the DeleteRealtimeEndpoint operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### deleteTags

    public DeleteTagsResult deleteTags(DeleteTagsRequest deleteTagsRequest)

Deletes the specified tags associated with an ML object. After this operation is complete, you can't recover deleted tags.

If you specify a tag that doesn't exist, Amazon ML ignores it.

Specified by:
  `deleteTags` in interface `AmazonMachineLearning`
Parameters:
  `deleteTagsRequest` -
Returns:
  Result of the DeleteTags operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InvalidTagException`
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### describeBatchPredictions

    public DescribeBatchPredictionsResult describeBatchPredictions(DescribeBatchPredictionsRequest describeBatchPredictionsRequest)

Returns a list of `BatchPrediction` operations that match the search criteria in the request.

Specified by:
  `describeBatchPredictions` in interface `AmazonMachineLearning`
Parameters:
  `describeBatchPredictionsRequest` -
Returns:
  Result of the DescribeBatchPredictions operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### describeBatchPredictions

    public DescribeBatchPredictionsResult describeBatchPredictions()

Description copied from interface: `AmazonMachineLearning`
Simplified method form for invoking the DescribeBatchPredictions operation.

Specified by:
  `describeBatchPredictions` in interface `AmazonMachineLearning`
See Also:
  `AmazonMachineLearning.describeBatchPredictions(DescribeBatchPredictionsRequest)`

#### describeDataSources

    public DescribeDataSourcesResult describeDataSources(DescribeDataSourcesRequest describeDataSourcesRequest)

Returns a list of `DataSource` that match the search criteria in the request.

Specified by:
  `describeDataSources` in interface `AmazonMachineLearning`
Parameters:
  `describeDataSourcesRequest` -
Returns:
  Result of the DescribeDataSources operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### describeDataSources

    public DescribeDataSourcesResult describeDataSources()

Description copied from interface: `AmazonMachineLearning`
Simplified method form for invoking the DescribeDataSources operation.

Specified by:
  `describeDataSources` in interface `AmazonMachineLearning`
See Also:
  `AmazonMachineLearning.describeDataSources(DescribeDataSourcesRequest)`

#### describeEvaluations

    public DescribeEvaluationsResult describeEvaluations(DescribeEvaluationsRequest describeEvaluationsRequest)

Returns a list of `DescribeEvaluations` that match the search criteria in the request.

Specified by:
  `describeEvaluations` in interface `AmazonMachineLearning`
Parameters:
  `describeEvaluationsRequest` -
Returns:
  Result of the DescribeEvaluations operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### describeEvaluations

    public DescribeEvaluationsResult describeEvaluations()

Description copied from interface: `AmazonMachineLearning`
Simplified method form for invoking the DescribeEvaluations operation.

Specified by:
  `describeEvaluations` in interface `AmazonMachineLearning`
See Also:
  `AmazonMachineLearning.describeEvaluations(DescribeEvaluationsRequest)`

#### describeMLModels

    public DescribeMLModelsResult describeMLModels(DescribeMLModelsRequest describeMLModelsRequest)

Returns a list of `MLModel` that match the search criteria in the request.

Specified by:
  `describeMLModels` in interface `AmazonMachineLearning`
Parameters:
  `describeMLModelsRequest` -
Returns:
  Result of the DescribeMLModels operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### describeMLModels

    public DescribeMLModelsResult describeMLModels()

Description copied from interface: `AmazonMachineLearning`
Simplified method form for invoking the DescribeMLModels operation.

Specified by:
  `describeMLModels` in interface `AmazonMachineLearning`
See Also:
  `AmazonMachineLearning.describeMLModels(DescribeMLModelsRequest)`

#### describeTags

    public DescribeTagsResult describeTags(DescribeTagsRequest describeTagsRequest)

Describes one or more of the tags for your Amazon ML object.

Specified by:
  `describeTags` in interface `AmazonMachineLearning`
Parameters:
  `describeTagsRequest` -
Returns:
  Result of the DescribeTags operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### getBatchPrediction

    public GetBatchPredictionResult getBatchPrediction(GetBatchPredictionRequest getBatchPredictionRequest)

Returns a `BatchPrediction` that includes detailed metadata, status, and data file information for a `Batch Prediction` request.

Specified by:
  `getBatchPrediction` in interface `AmazonMachineLearning`
Parameters:
  `getBatchPredictionRequest` -
Returns:
  Result of the GetBatchPrediction operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### getDataSource

    public GetDataSourceResult getDataSource(GetDataSourceRequest getDataSourceRequest)

Returns a `DataSource` that includes metadata and data file information, as well as the current status of the `DataSource`.

`GetDataSource` provides results in normal or verbose format. The verbose format adds the schema description and the list of files pointed to by the DataSource to the normal format.

Specified by:
  `getDataSource` in interface `AmazonMachineLearning`
Parameters:
  `getDataSourceRequest` -
Returns:
  Result of the GetDataSource operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### getEvaluation

    public GetEvaluationResult getEvaluation(GetEvaluationRequest getEvaluationRequest)

Returns an `Evaluation` that includes metadata as well as the current status of the `Evaluation`.

Specified by:
  `getEvaluation` in interface `AmazonMachineLearning`
Parameters:
  `getEvaluationRequest` -
Returns:
  Result of the GetEvaluation operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### getMLModel

    public GetMLModelResult getMLModel(GetMLModelRequest getMLModelRequest)

Returns an `MLModel` that includes detailed metadata, data source information, and the current status of the `MLModel`.

`GetMLModel` provides results in normal or verbose format.

Specified by:
  `getMLModel` in interface `AmazonMachineLearning`
Parameters:
  `getMLModelRequest` -
Returns:
  Result of the GetMLModel operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### predict

    public PredictResult predict(PredictRequest predictRequest)

Generates a prediction for the observation using the specified `ML Model`.

<note>Note

Not all response parameters will be populated. Whether a response parameter is populated depends on the type of model requested.

</note>

Specified by:
  `predict` in interface `AmazonMachineLearning`
Parameters:
  `predictRequest` -
Returns:
  Result of the Predict operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `LimitExceededException` - The subscriber exceeded the maximum number of operations. This exception can occur when listing objects such as `DataSource`.
  `InternalServerException` - An error on the server occurred when trying to process a request.
  `PredictorNotMountedException` - The exception is thrown when a predict request is made to an unmounted `MLModel`.

#### updateBatchPrediction

    public UpdateBatchPredictionResult updateBatchPrediction(UpdateBatchPredictionRequest updateBatchPredictionRequest)

Updates the `BatchPredictionName` of a `BatchPrediction`.

You can use the `GetBatchPrediction` operation to view the contents of the updated data element.

Specified by:
  `updateBatchPrediction` in interface `AmazonMachineLearning`
Parameters:
  `updateBatchPredictionRequest` -
Returns:
  Result of the UpdateBatchPrediction operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### updateDataSource

    public UpdateDataSourceResult updateDataSource(UpdateDataSourceRequest updateDataSourceRequest)

Updates the `DataSourceName` of a `DataSource`.

You can use the `GetDataSource` operation to view the contents of the updated data element.

Specified by:
  `updateDataSource` in interface `AmazonMachineLearning`
Parameters:
  `updateDataSourceRequest` -
Returns:
  Result of the UpdateDataSource operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### updateEvaluation

    public UpdateEvaluationResult updateEvaluation(UpdateEvaluationRequest updateEvaluationRequest)

Updates the `EvaluationName` of an `Evaluation`.

You can use the `GetEvaluation` operation to view the contents of the updated data element.

Specified by:
  `updateEvaluation` in interface `AmazonMachineLearning`
Parameters:
  `updateEvaluationRequest` -
Returns:
  Result of the UpdateEvaluation operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### updateMLModel

    public UpdateMLModelResult updateMLModel(UpdateMLModelRequest updateMLModelRequest)

Updates the `MLModelName` and the `ScoreThreshold` of an `MLModel`.

You can use the `GetMLModel` operation to view the contents of the updated data element.

Specified by:
  `updateMLModel` in interface `AmazonMachineLearning`
Parameters:
  `updateMLModelRequest` -
Returns:
  Result of the UpdateMLModel operation returned by the service.
Throws:
  `InvalidInputException` - An error on the client occurred. Typically, the cause is an invalid input value.
  `ResourceNotFoundException` - A specified resource cannot be located.
  `InternalServerException` - An error on the server occurred when trying to process a request.

#### getCachedResponseMetadata

    public ResponseMetadata getCachedResponseMetadata(AmazonWebServiceRequest request)

Returns additional metadata for a previously executed successful, request, typically used for debugging issues where a service isn't acting as expected. This data isn't considered part of the result data returned by an operation, so it's available through this separate, diagnostic interface.

Response metadata is only cached for a limited period of time, so if you need to access this extra diagnostic information for an executed request, you should use this method to retrieve it as soon as possible after executing the request.

Specified by:
  `getCachedResponseMetadata` in interface `AmazonMachineLearning`
Parameters:
  `request` - The originally executed request
Returns:
  The response metadata for the specified request, or null if none is available.

#### waiters

    public AmazonMachineLearningWaiters waiters()

Specified by:
  `waiters` in interface `AmazonMachineLearning`